;straight RLE decoder version 2
;datas are packed by byte
;0xXXXXYYYY
;YYYY = count
;XXXX = data
;NULL count mark end of datas
;datas are finished with NULL byte

;optimisation has been done unrolling filling loop

;in HL=datas DE=sprite
				;n - b
RLE_Decoder:
	ld C,%00001111		;2 - 2

.RLE_loop	
	ld A,(HL)		;2 	- 1
	and C			;1 	- 1
	jr z,RLE_end		;3/2	- 2

	ld B,A			;1	- 1
	ld A,(HL)		;2	- 1
	inc HL			;2	- 1

	rlca			;1	- 1
	rlca			;1	- 1
	rlca			;1	- 1 
	rlca			;1	- 1

.RLE_fill
;pixel 1
	ld (DE),A		;2	- 1
	inc E			;1	- 1
	dec B			;1	- 1
	jr z,RLE_loop		;2	- 3/2
;pixel 2
	ld (DE),A		;2	- 1
	inc E			;1	- 1
	dec B			;1	- 1
	jr z,RLE_loop		;2	- 3/2
;pixel 3
	ld (DE),A		;2	- 1
	inc E			;1	- 1
	dec B			;1	- 1
	jr z,RLE_loop		;2	- 3/2
;pixel 4
	ld (DE),A		;2	- 1
	inc E			;1	- 1
	dec B			;1	- 1
	jr z,RLE_loop		;2	- 3/2
;pixel 5
	ld (DE),A		;2	- 1
	inc E			;1	- 1
	dec B			;1	- 1
	jr z,RLE_loop		;2	- 3/2
;pixel 6
	ld (DE),A		;2	- 1
	inc E			;1	- 1
	dec B			;1	- 1
	jr z,RLE_loop		;2	- 3/2
;pixel 7
	ld (DE),A		;2	- 1
	inc E			;1	- 1
	dec B			;1	- 1
	jr z,RLE_loop		;2	- 3/2
;pixel 8
	ld (DE),A		;2	- 1
	inc E			;1	- 1
	dec B			;1	- 1
	jr z,RLE_loop		;2	- 3/2
;pixel 9
	ld (DE),A		;2	- 1
	inc E			;1	- 1
	dec B			;1	- 1
	jr z,RLE_loop		;2	- 3/2
;pixel 10
	ld (DE),A		;2	- 1
	inc E			;1	- 1
	dec B			;1	- 1
	jr z,RLE_loop		;2	- 3/2
;pixel 11
	ld (DE),A		;2	- 1
	inc E			;1	- 1
	dec B			;1	- 1
	jr z,RLE_loop		;2	- 3/2
;pixel 12
	ld (DE),A		;2	- 1
	inc E			;1	- 1
	dec B			;1	- 1
	jr z,RLE_loop		;2	- 3/2
;pixel 13
	ld (DE),A		;2	- 1
	inc E			;1	- 1
	dec B			;1	- 1
	jr z,RLE_loop		;2	- 3/2
;pixel 14
	ld (DE),A		;2	- 1
	inc E			;1	- 1
	dec B			;1	- 1
	jr z,RLE_loop		;2	- 3/2
;pixel 15 - last pixel
	ld (DE),A		;2	- 1
	inc E			;1	- 1
	dec B			;1	- 1
	jr RLE_loop		;3	- 2
.RLE_end
	ret			;3	- 1
RLE_DecoderSize EQU $-RLE_Decoder

;last loop = 6
;full loop = 14

;one pixel  = 7
;extra pixel = 6

;extra = 5
;header = 20

;minimal cost per pixel = 21
;per extra pixel = 6